package cn.com.poc.thirdparty.resource.demand.ai.function;

import cn.com.poc.common.service.RedisService;
import cn.com.poc.common.utils.BlContext;
import com.google.gson.Gson;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class SearchMemoryContentFunction extends AbstractLargeModelFunction {

    @Resource
    private RedisService redisService;

    @Override
    public String doFunction(String content, String key) {
        // 查询用户相关信息（什么内容都可以）
        String result;
        String longMemoryKey = key + ":" + BlContext.getCurrentUserNotException().getUserId().toString() + ":" + "longMemory";
        result = redisService.hmget(longMemoryKey).toString();
        return result;
    }

    @Override
    public List<String> getLLMConfig() {
        Map<String, Object> config = new HashMap<>();

        Map<String, Object> function = new HashMap<>();

        Map<String, Object> content = new HashMap<>();
        content.put("type", "string");
        content.put("description","信息说明");

        Map<String, Object> properties = new HashMap<>();
        properties.put("content", content);

        Map<String, Object> parameters = new HashMap<>();
        parameters.put("type", "object");
        parameters.put("properties",properties);

        List<String> required = new ArrayList<>();
        required.add("content");
        parameters.put("required", required);

        function.put("name", "search_memory_content");
        function.put("description", "获取用户相关信息");
        function.put("parameters", parameters);

        config.put("type", "function");
        config.put("function", function);

        // 将 Map 转换为 JSON 字符串
        Gson gson = new Gson();
        String jsonString = gson.toJson(config);

        List<String> resultList = new ArrayList<>();
        resultList.add(jsonString);
        return resultList;
    }

    @Override
    public List<String> getVariableStructureLLMConfig(String[] variableStructure) {
        return null;
    }
}
