package cn.com.poc.thirdparty.resource.demand.ai.function;

import cn.com.poc.common.service.RedisService;
import cn.com.poc.common.utils.BlContext;
import cn.hutool.json.JSONObject;
import com.google.gson.Gson;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class SetValueMemoryFunction extends AbstractLargeModelFunction {
    @Resource
    private RedisService redisService;

    @Override
    //todo 保存【变量】方法重构
    public String doFunction(String content, String key) {
        // todo 执行保存变量的操作
        // 创建 JSONObject 对象
        JSONObject jsonObject = new JSONObject(content);
        // 提取 contentName 和 contentValue
        String contentName = jsonObject.getStr("contentName");
        String contentValue = jsonObject.getStr("contentValue");
        String contentKey = key + ":" + BlContext.getCurrentUserNotException().getUserId().toString() + ":" + contentName;
        redisService.set(contentKey, contentValue);
        return "SUCCESS";
    }

    @Override
    public List<String> getLLMConfig() {
        return null;
    }

    @Override
    public List<String> getVariableStructureLLMConfig(String[] variableStructure) {
        Map<String, Object> config = new HashMap<>();
        Map<String, Object> function = new HashMap<>();

        Map<String, Object> parameters = new HashMap<>();
        parameters.put("type", "object");

        List<String> required = new ArrayList<>();
        required.add("contentName");
        required.add("contentValue");
        parameters.put("required", required);
        Map<String, Object> properties = new HashMap<>();
        Map<String, Object> contentName = new HashMap<>();
        contentName.put("type", "string");
        contentName.put("description", "内容名");
        contentName.put("enum", variableStructure); // 设置变量
        Map<String, Object> contentValue = new HashMap<>();
        contentValue.put("type", "string");
        contentValue.put("description", "内容值");
        properties.put("contentName", contentName);
        properties.put("contentValue", contentValue);
        parameters.put("properties", properties);
        parameters.put("type", "object");

        function.put("name", "set_value_memory");
        function.put("description", "用enum给定的内容名来保存用户想记录的内容值");
        function.put("parameters", parameters);

        config.put("type", "function");
        config.put("function", function);

        // 将 Map 转换为 JSON 字符串
        Gson gson = new Gson();
        String jsonString = gson.toJson(config);

        List<String> resultList = new ArrayList<>();
        resultList.add(jsonString);
        return resultList;
    }
}
